/*

	f[^K[

	Copyrights 2010,  Yoshi Hiroshi.

 */

/*
 *      Analog Input
 *
 *          ADC0/PC0:   x            1.1V
 *          ADC1/PC1:   LpV^x      1.1V
 *          ADC2/PC2:   LpV^[qd  5.5V
 *          ADC3/PC3:   [dd          }55mV
 */
#define MAX_ADC_PORT                4
#define MAX_DATA_COUNT              100     // 100mS
#define ADC_BIPOLAR_ZERO            (512L*MAX_DATA_COUNT)

/*
 *      XBb`
 *
 *          PD7:ADC2lϊ    0:lϊADCl̂܂ܑM
 *                              1:l5.5VFSɕϊđMB
 *                              @ADC2:ɕϊ
 *          PD6:ADC3lϊ    0:lϊADCl̂܂ܑM
 *                              1:l}55mVFSɕϊđMBi[_͖0.55Vj
 *          PD5:
 */
#define ADC_CONV_CAP_VOLT       (bit_is_set(PIND,7))
#define ADC_CONV_CAP_CURR       (bit_is_set(PIND,6))

/*
 *      o
 */
#define CHARGE_ENABLE           (PORTD |= _BV(PD3))
#define CHARGE_DISABLE          (PORTD &= ~_BV(PD3))
#define DISCHARGE_ENABLE        (PORTD |= _BV(PD2))
#define DISCHARGE_DISABLE       (PORTD &= ~_BV(PD2))

#define TIME_INITIAL_WAIT       10000         // 10 Sec.
#define TIME_CYCLE_GAP          10000         // 10 Sec.
#define TIME_CYCLE_CHARGE       90000        // 120 Sec. = 2 min.
#define TIME_CYCLE_DISCHARGE    90000        // 120 Sec. = 2 min.

// mode / status
#define MODE_STOP               0
#define MODE_CHARGE             10
#define MODE_IDLE1              20
#define MODE_DISCHARGE          30
#define MODE_IDLE2              40

/*
 *
 */
#define LED_REVERSE_RED             {PORTB ^= 0x02;}
#define LED_SET_RED                 {PORTB |= 0x02;}
#define LED_CLEAR_RED               {PORTB &= ~0x02;}
#define LED_REVERSE_YELLOW          {PORTB ^= 0x01;}
#define LED_SET_YELLOW              {PORTB |= 0x01;}
#define LED_CLEAR_YELLOW            {PORTB &= ~0x01;}

