/*

	GlM[E[^

	eeProm.c

	Copyrights 2010,  Yoshi Hiroshi.

 */


#include <avr/eeprom.h>
#include "eeProm.h"
#include "i2cTinyLcd.h"

/*
*/
unsigned char contrast EEMEM = I2C_LCD_DEFAULT_CONTRAST;
char capListIndex EEMEM = 1;
int capacitance EEMEM = { 2400 };
int tableCapacitance EEMEM = { 2400 };

/*
        LpV^̃Xg
*/
struct capList_ capacitanceList[] EEMEM= 
{
    {"DSC  1,200F", 1200},
    {"DSC  2,400F", 2400},
    {"DLA    350F",  350},
    {"DLA    700F",  700},
    {"DLC    350F",  350},
    {"DLC    700F",  700},
    {"DLC  1,400F", 1400},
    {"DLE  2,300F", 2300},
    {"DLB  2,500F", 2500}
};

/*
    obeACR\̂߂̓d臒l
*/
int batMeterThreshold[] EEMEM = 
{
     900,
    1100,
    1300,
    1600,
    1900,
    2100,
    2500
};


/*
    Ódeʂxő傫ςƂApӂ
*/
int tempTable[TABLE_NUM_TEMP] EEMEM = {
    -20,
    -10,
    0,
    25,
    40,
    0x7FFF
};

/*
    dɂĕςÓdeʂ̃e[u
*/
struct _capTable convTable[TABLE_NUM_TEMP][TABLE_NUM_ELEMENT] EEMEM =
{
    {                   // -10eʃe[u
        { 100, 1800},
        { 400, 1825},
        { 600, 1851},
        { 900, 1915},
        {1400, 2052},
        {2100, 2275},
        {2500, 2400},
        {   0,    0}
    },
    {                   // 0eʃe[u
        { 100, 1800},
        { 400, 1825},
        { 600, 1851},
        { 900, 1915},
        {1400, 2052},
        {2100, 2275},
        {2500, 2400},
        {   0,    0}
    },
    {                   // 15eʃe[u
        { 100, 1800},
        { 400, 1825},
        { 600, 1851},
        { 900, 1915},
        {1400, 2052},
        {2100, 2275},
        {2500, 2400},
        {   0,    0}
    },
    {                   // 25eʃe[u
        { 100, 1800},
        { 400, 1825},
        { 600, 1851},
        { 900, 1915},
        {1400, 2052},
        {2100, 2275},
        {2500, 2400},
        {   0,    0}
    },
    {                   // 40eʃe[u
        { 100, 1800},
        { 400, 1825},
        { 600, 1851},
        { 900, 1915},
        {1400, 2052},
        {2100, 2275},
        {2500, 2400},
        {   0,    0}
    }
};


long getCapacity(int volt, int temp)     // volt:mVP, temp:0.1P
{
    long cap;
    long cap1;
    int temp0 = 1;
    int temp1 = 0;
// xe[u`FbNAxԂ̕KvmF
    unsigned char tempIndex = 0;
    unsigned char tempInterpolation = 0;
    for(unsigned char index = 0; index < TABLE_NUM_TEMP; index++)
    {
        if(CAP_TABLE_GET_TEMP(index) == 0x7FFF) break;
        tempIndex = index;
        temp0 = CAP_TABLE_GET_TEMP(index) * 10;
        if(temp0 >= temp) {
            if(index != 0) {
                tempInterpolation = 1;
                temp1 = CAP_TABLE_GET_TEMP(index - 1) * 10;
            }
            break;
        }
    }

// dɂÓdeʕ
    cap = CAP_TABLE_GET_CAP(tempIndex, 0);
    for(unsigned char index = 0; index < TABLE_NUM_ELEMENT; index++)
    {
        if(CAP_TABLE_GET_VOLT(tempIndex, index) >= volt) {
            if(index != 0) {
                cap = CAP_TABLE_GET_CAP(tempIndex, index) -
                      ( (CAP_TABLE_GET_CAP(tempIndex, index) - 
                         CAP_TABLE_GET_CAP(tempIndex, index - 1) ) *
                        (CAP_TABLE_GET_VOLT(tempIndex, index) - volt) ) /
                      (CAP_TABLE_GET_VOLT(tempIndex, index) - 
                       CAP_TABLE_GET_VOLT(tempIndex, index - 1));
            }
            break;
        }
        if(CAP_TABLE_GET_CAP(tempIndex, index) != 0) cap = CAP_TABLE_GET_CAP(tempIndex, index);
        if(CAP_TABLE_GET_VOLT(tempIndex, index) == 0) break;
    }

// xɂ
    if(tempInterpolation) {
        tempIndex--;
        cap1 = CAP_TABLE_GET_CAP(tempIndex, 0);
        for(unsigned char index = 0; index < TABLE_NUM_ELEMENT; index++)
        {
            if(CAP_TABLE_GET_VOLT(tempIndex, index) >= volt) {
                if(index != 0) {
                    cap1 = CAP_TABLE_GET_CAP(tempIndex, index) -
                          ( (CAP_TABLE_GET_CAP(tempIndex, index) - 
                             CAP_TABLE_GET_CAP(tempIndex, index - 1) ) *
                            (CAP_TABLE_GET_VOLT(tempIndex, index) - volt) ) /
                          (CAP_TABLE_GET_VOLT(tempIndex, index) - 
                           CAP_TABLE_GET_VOLT(tempIndex, index - 1));
                }
                break;
            }
            if(CAP_TABLE_GET_CAP(tempIndex, index) != 0) cap1 = CAP_TABLE_GET_CAP(tempIndex, index);
            if(CAP_TABLE_GET_VOLT(tempIndex, index) == 0x7FFF) break;
        }
        cap = cap - (cap - cap1) * (temp0 - temp) / (temp0 - temp1);
    }
    cap = cap * (long)GET_CAPACITANCE / (long)GET_TABLE_CAPACITANCE;
    return cap;
}
