/*

	GlM[E[^

	eeProm.h

	Copyrights 2010,  Yoshi Hiroshi.

 */


#include <avr/eeprom.h>

#define WRITE_CONTRAST(c)           eeprom_write_byte((uint8_t*)&contrast, c)
#define GET_CONTRAST()              (unsigned char)eeprom_read_byte((uint8_t*)&contrast)
#define WRITE_CAPACITANCE(cap)      eeprom_write_word((uint16_t*)&capacitance, cap)
#define WRITE_CAPLIST_INDEX(inx)    eeprom_write_byte((uint8_t*)&capListIndex, inx)
#define GET_CAPACITANCE             (int)eeprom_read_word((uint16_t*)&capacitance)
#define GET_CAPLIST_INDEX           (unsigned char)eeprom_read_byte((uint8_t*)&capListIndex)
#define GET_CAP_TITLE(inx,pos)      (char)eeprom_read_byte((uint8_t*)&capacitanceList[inx].title[pos])
#define GET_CAP_VALUE(inx)          (int)eeprom_read_word((uint16_t*)&capacitanceList[inx].capacitance)
#define GET_TABLE_CAPACITANCE       (int)eeprom_read_word((uint16_t*)&tableCapacitance)
#define CAP_TABLE_GET_TEMP(i)       (int)eeprom_read_word((uint16_t*)&tempTable[i])
#define CAP_TABLE_GET_VOLT(t,i)     (int)eeprom_read_word((uint16_t*)&convTable[t][i].volt)
#define CAP_TABLE_GET_CAP(t,i)      (long)eeprom_read_dword((uint32_t*)&convTable[t][i].cap)
#define BAT_METER_THRESHOLD(i)      (int)eeprom_read_word((uint16_t*)&batMeterThreshold[i])
#define TABLE_NUM_TEMP              6
#define TABLE_NUM_ELEMENT           8

extern unsigned char contrast EEMEM;
extern int capacitance EEMEM;
extern char capListIndex EEMEM;
struct capList_ {
    char title[12];
    int capacitance;
};
extern struct capList_ capacitanceList[] EEMEM;

extern int batMeterThreshold[] EEMEM;
extern int tempTable[TABLE_NUM_TEMP] EEMEM;

struct _capTable {
    int volt;       // dmVŐݒ   ex: 2.1V -> 2100
    long cap;       // eʂFŐݒ    ex:2400F
};
extern struct _capTable convTable[TABLE_NUM_TEMP][TABLE_NUM_ELEMENT] EEMEM;

long getCapacity(int volt, int temp);
