/*

	GlM[E[^

	i2cTinyLcd.h

	IICڑLCDW[Rg[B

	Copyrights 2010,  Yoshi Hiroshi.

 */
#include <avr/io.h>
#include <util/delay.h>

#define I2C_LCD_USE_STDIO_FUNCTION

#define I2C_LCD_SLAVEADDRESS            0x3E
#define I2C_LCD_CONTROL_CMND            0x00
#define I2C_LCD_CONTROL_DATA            0x40
#define I2C_LCD_DEFAULT_CONTRAST        0x28

void i2cInit();
void i2cLcdInit();
void i2cLcdData(char c);
void i2cLcdCmd(char c);
void i2cLcdPuts(char* str);
void i2cLcdPutsE(char* str);
void i2cLcdPutsP(char* str);
void i2cLcdClear();
void i2cLcdPosition(char row, char col);
int  i2cLcdGetContrast();
void i2cLcdSetContrast(int con);
void i2cLcdShowBatteryIcon(int icon);
void i2cLcdShowBattenIcon(int icon);

#ifdef I2C_LCD_USE_STDIO_FUNCTION
#include <stdio.h>
int	i2cLcdPutChar(char c, FILE *stream);
int	i2cLcdGetChar(FILE *stream);
#endif

void i2cSendStartCondition();
void i2cSendStopCondition();
unsigned char i2cWriteData(unsigned char val);
unsigned char i2cWrite2(unsigned char slaveAdrs, unsigned char control, unsigned char data);

//===============================================
//
//		Definitions for Internal Use
//
#define LCD_COMMAND_FUNCTIONSET	        	0x38
#define LCD_COMMAND_INSTRUCTION_TBL_SEL    	0x39
#define LCD_COMMAND_OSC_FREQ            	0x14
#define LCD_COMMAND_CONTRAST_L           	0x70
#define LCD_COMMAND_CONTRAST_H           	0x5C
#define LCD_COMMAND_FOLLOWER               	0x6C
#define LCD_COMMAND_CLEAR		        	0x01
#define LCD_COMMAND_HOME		        	0x02
#define LCD_COMMAND_ENTRYMODE	        	0x04
#define 	LCD_COMMAND_ENTRYMODE_INC	    	0x02
#define 	LCD_COMMAND_ENTRYMODE_DEC	    	0x00
#define 	LCD_COMMAND_ENTRYMODE_SHIFT	    	0x01
#define 	LCD_COMMAND_ENTRYMODE_NOSHIFT   	0x00
#define LCD_COMMAND_DISP_CONTROL        	0x08
#define 	LCD_COMMAND_DISPCTRL_DISP_ON    	0x04
#define 	LCD_COMMAND_DISPCTRL_DISP_OFF   	0x00
#define 	LCD_COMMAND_DISPCTRL_CRSL_ON    	0x02
#define 	LCD_COMMAND_DISPCTRL_CRSL_OFF   	0x00
#define 	LCD_COMMAND_DISPCTRL_BLNK_ON    	0x01
#define 	LCD_COMMAND_DISPCTRL_BLNK_OFF   	0x00
#define LCD_COMMAND_SET_ADDRESS	        	0x80
#define LCD_COMMAND_SET_ICON_ADDRESS        0x40

//--- I2C value
#define I2C_REQUEST_WRITE		0
#define I2C_REQUEST_READ		1
//--- Inernal Value
#define DELAY_SHORT				5
#define DELAY_LONG				10

// Device Dependent Configuration

//--- Bit Assignment
#define I2C_SCL					0
#define I2C_SDA					1
//--- Register Assignment
#define I2C_SCL_PORT			PORTB
#define I2C_SCL_DDR				DDRB
#define I2C_SCL_PIN				PINB
#define I2C_SDA_PORT			PORTB
#define I2C_SDA_DDR				DDRB
#define I2C_SDA_PIN				PINB

//--- SCL MACRO Assignment
#define I2C_SCL_AS_INPUT		I2C_SCL_DDR &= ~_BV(I2C_SCL)
#define I2C_SCL_AS_OUTPUT		I2C_SCL_DDR |= _BV(I2C_SCL)
#define I2C_SCL_FREE			I2C_SCL_PORT |= _BV(I2C_SCL); I2C_SCL_AS_INPUT
#define I2C_SCL_SET_LOW			I2C_SCL_PORT &= ~_BV(I2C_SCL); I2C_SCL_AS_OUTPUT
#define I2C_SCL_CURR_VAL		(I2C_SCL_PIN  & _BV(I2C_SCL))
//--- SDA MACRO Assignment
#define I2C_SDA_AS_INPUT		I2C_SDA_DDR &= ~_BV(I2C_SDA)
#define I2C_SDA_AS_OUTPUT		I2C_SDA_DDR |= _BV(I2C_SDA)
#define I2C_SDA_FREE			I2C_SDA_PORT |= _BV(I2C_SDA); I2C_SDA_AS_INPUT
#define I2C_SDA_SET_LOW			I2C_SDA_PORT &= ~_BV(I2C_SDA); I2C_SDA_AS_OUTPUT
#define I2C_SDA_CURR_VAL		(I2C_SDA_PIN  & _BV(I2C_SDA))

