/*

	GlM[E[^

	setting.c

	ELpV^eʂI
	ELCD̃RgXgݒ肷B

	Copyrights 2010,  Yoshi Hiroshi.

 */

#include <stdio.h>
#include "eeprom.h"
#include "i2cTinyLcd.h"
#include "setting.h"
#include "switch.h"

volatile unsigned char capIndex;
volatile unsigned char contiguousCount;

void print_E(char* ptr)
{
    char c = GET_CAP_TITLE(capIndex, 0);
    unsigned char index = 1;
    while(c != 0) {
        printf("%c", c);
        c = GET_CAP_TITLE(capIndex, index);
        index++;
    }
}

void showCapacitance()
{
    capIndex = GET_CAPLIST_INDEX;
    i2cLcdPosition(1, 0);
    printf("  ");
    print_E(capacitanceList[capIndex].title);
    printf("  ");
}

void selectCap()
{
    if(IS_LEFT_PUSHED()) {
        CLR_LEFT_PUSHED();
        if(capIndex >= 8) {
            capIndex = 0;
        } else {
            capIndex++;
        }
        i2cLcdPosition(1, 0);
        printf("  ");
        print_E(capacitanceList[capIndex].title);
//        printf("  ");
    }
    if(IS_RIGHT_PUSHED()) {
        CLR_RIGHT_PUSHED();
        if(capIndex == 0) {
            capIndex = 8;
        } else {
            capIndex--;
        }
        i2cLcdPosition(1, 0);
        printf("  ");
        print_E(capacitanceList[capIndex].title);
//        printf("  ");
    }
}

void showContrastTitle()
{
    char cont = i2cLcdGetContrast();
    i2cLcdClear();
    printf("׽ ò %3d", cont);
    i2cLcdPosition(1, 0);
    if(cont <= 24) cont = 24;
    cont = (cont - 24) / 2;
    for(unsigned char count = 0; count < 16;count++)
    {
        if((cont) > count) {
            printf("%c", 0x18);
        } else {
            printf(" ");
        }
    }
}

void upContrast(char dispFlag)
{
    char cont = i2cLcdGetContrast();
    if(cont < 55) {
        cont+= 2;
        i2cLcdSetContrast(cont);
        if(dispFlag) showContrastTitle();
    }
}

void downContrast(char dispFlag)
{
    char cont = i2cLcdGetContrast();
    if(cont > 25) {
        cont -= 2;
        i2cLcdSetContrast(cont);
        if(dispFlag) showContrastTitle();
    }
}

void setContrast(char dispFlag)
{
    if(IS_RIGHT_LONG()) {
        contiguousCount++;
        if(contiguousCount >= 4) {
            contiguousCount = 0;
            downContrast(dispFlag);
        }
    } else 
    if(IS_RIGHT_PUSHED()) {
        downContrast(dispFlag);
        CLR_RIGHT_PUSHED();
    }
    if(IS_LEFT_LONG()) {
        contiguousCount++;
        if(contiguousCount >= 4) {
            contiguousCount = 0;
            upContrast(dispFlag);
        }
    } else 
    if(IS_LEFT_PUSHED()) {
        upContrast(dispFlag);
        CLR_LEFT_PUSHED();
    }
}


unsigned char checkBottun(unsigned char dispMode)
{
    if(IS_LEFT_LONG() && IS_RIGHT_LONG()) {
        switch(dispMode) {
        case DISP_MODE_NONE:
/*
            dispMode = DISP_MODE_CONTRAST;
            showContrastTitle();
            break;
        case DISP_MODE_CONTRAST:
            if(GET_CONTRAST() != i2cLcdGetContrast()) {
                eeprom_busy_wait();
                WRITE_CONTRAST(i2cLcdGetContrast());
            }
*/
            dispMode = DISP_MODE_SELECT_CAP;
            i2cLcdClear();
            printf(" ߼ݽ   ");
            showCapacitance();
            break;
        case DISP_MODE_SELECT_CAP:
            if(capIndex != GET_CAPLIST_INDEX) {
                eeprom_busy_wait();
                WRITE_CAPLIST_INDEX(capIndex);
                eeprom_busy_wait();
                WRITE_CAPACITANCE(GET_CAP_VALUE(capIndex));
            }
            dispMode = DISP_MODE_NONE;
            break;
        }
        CLR_LEFT_LONG();
        CLR_RIGHT_LONG();
    } else {
        switch(dispMode) {
        case DISP_MODE_NONE:
            setContrast(0);
            break;
        case DISP_MODE_CONTRAST:
            setContrast(1);
            break;
        case DISP_MODE_SELECT_CAP:
            selectCap();
            break;
        }
    }
    return dispMode;
}
