/*

	GlM[E[^

	switch.c

	XBb`̎荞

	Copyrights 2010,  Yoshi Hiroshi.

 */


#include <avr/io.h>
#include "switch.h"

unsigned char swRight;
unsigned char swLeft;
unsigned int swRightCount;
unsigned int swLeftCount;

void switchInit()
{
    PORTB = 0x18;
    swRight = 0;
    swLeft = 0;
    SW_SET(swRight, SW_PREV_FLAG, SW_IN_RIGHT);
    SW_SET(swLeft, SW_PREV_FLAG, SW_IN_LEFT);
}

void checkSwitchStatus(unsigned char currVal, 
                        unsigned char* sw,
                        unsigned int* swCount)
{
    SW_SET(*sw, SW_CURR_FLAG, currVal);
    if(SW_GET(*sw, SW_CURR_FLAG) == SW_GET(*sw, SW_PREV_FLAG)) {
        if((*swCount)++ >= 320) *swCount = 320;
        if(*swCount == 2) {
            if(SW_IS_OFF(*sw, SW_CURR_FLAG)) {
                SW_ON(*sw, SW_PUSH_FLAG);
                SW_OFF(*sw, SW_RELEASE_FLAG);
            }
        }
        if(*swCount == 24) { // 1sec
            if(SW_IS_OFF(*sw, SW_CURR_FLAG)) {
                SW_ON(*sw, SW_LONG_FLAG);
                SW_OFF(*sw, SW_PUSH_FLAG);
                SW_OFF(*sw, SW_RELEASE_FLAG);
            }
        }
    } else {
        if(*swCount >= 2) {
            if(SW_IS_ON(*sw, SW_CURR_FLAG)) {
                SW_ON(*sw, SW_RELEASE_FLAG);
                SW_OFF(*sw, SW_PUSH_FLAG);
                SW_OFF(*sw, SW_LONG_FLAG);
            }
        }
        *swCount = 0;
        SW_SET(*sw, SW_PREV_FLAG, SW_GET(*sw, SW_CURR_FLAG));
    }
}

void checkSwitches()                      // process every 32mS
{
    checkSwitchStatus(SW_IN_RIGHT, &swRight, &swRightCount);
    checkSwitchStatus(SW_IN_LEFT, &swLeft, &swLeftCount);
}
